/*
alentry.c -- ASPI Library (AspiEntry) Source File

Copyright (C) 1993 Roger C. Pao <rpao@mts.mivj.ca.us>

10/23/93 rpao	Modified & posted to Usenet community.
09/18/93 rpao	Created: Sat Sep 18 06:44:17 PDT 1993
*/


#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>
#include <stdio.h>


void (__far *AspiEntry)(void __far *Srb)=NULL;


/*
InitializeAspiEntry
	Attempts to locate and return the ASPI call entry within the
	last loaded DOS SCSI Manager.  The SCSI Manager is opened and
	closed after getting the ASPI entry point.
Returns:
	0: initialized okay
	otherwise: error
*/
int InitializeAspiEntry(void)
{
  char *ScsiMgrDevice="SCSIMGR$\0";
  int ScsiMgrFileHandle=-1;

  if ((ScsiMgrFileHandle=open(ScsiMgrDevice,O_RDONLY|O_BINARY))!=-1)
  {
    __asm
    {
      ;DOS IOCTL READ
      mov	bx, ScsiMgrFileHandle
      mov	ax, 4402h
      lea	dx, AspiEntry
      mov	cx, 4
      int	21h
    }
    close(ScsiMgrFileHandle);
  } else
    return 1;

  return 0;
}
